#include <iostream>
#include <vector>

using namespace std;

int t;
vector<int> low;
vector<int> num;
vector<int> s;
vector<bool> in_s;

int c;
vector<int> col;

void dfs(int u, vector< vector<int> >& graf) {
	low[u] = num[u] = ++t;
	s.push_back(u);
	in_s[u] = true;

	for(int v : graf[u])
		if(num[v] == 0) {
			dfs(v, graf);
			low[u] = min(low[u], low[v]);
		}
		else if(in_s[v])
			low[u] = min(low[u], num[v]);

	if(low[u] == num[u]) {
		int tu = -1;
		while(tu != u) {
			tu = s.back();
			in_s[tu] = false;
			s.pop_back();
			col[tu] = c;
		}
		c++;
	}
}

vector< vector<bool> > condense(vector<int>& col, vector< vector<int> >& graf) {
	vector< vector<bool> > cgraf(c, vector<bool>(c));

	for(int u = 0; u < graf.size(); u++)
		for(int v : graf[u])
			if(col[u] != col[v])
				cgraf[col[u]][col[v]] = true;

	return cgraf;
}

int main() {
	int n, m;
	cin >> n >> m;

	vector< vector<int> > graf(n);
	for(int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;

		graf[u].push_back(v);
	}

	t = 0;
	low = vector<int>(n);
	num = vector<int>(n);
	in_s = vector<bool>(n);
	c = 0;
	col = vector<int>(n);
	for(int i = 0; i < n; i++)
		if(num[i] == 0)
			dfs(i, graf);

	vector< vector<bool> > cond = condense(col, graf);
	for(int i = 0; i < c; i++) {
		for(int j = 0; j < c; j++)
			cout << cond[i][j] << ' ';
		cout << '\n';
	}

	return 0;
}
