#include <iostream>
#include <vector>
#include <set>
#include <limits>
#include <algorithm>

using namespace std;

using edge = pair<int, int>;

vector<int> dijkstra(int u, vector< vector<edge> >& graf) {
	vector<int> d(graf.size(), numeric_limits<int>::max());
	set< pair<int, int> > pq;

	pq.insert({d[u] = 0, u});
	while(!pq.empty()) {
		int v = pq.begin()->second;
		pq.erase(pq.begin());

		for(auto e : graf[v]) {
			int w = e.first, t = e.second;
			if(d[v] + t < d[w]) {
				pq.erase({d[w], w});
				d[w] = d[v] + t;
				pq.insert({d[w], w});
			}
		}
	}

	return d;
}

int main() {
	int n, m, x, y, w;
	cin >> n >> m;

	vector< vector<edge> > graf(n);
	for(int i = 0; i < m; i++) {
		cin >> x >> y >> w;
		graf[y].push_back({x, w});
	}

	vector<int> dist = dijkstra(0, graf);

	auto it = max_element(dist.begin(), dist.end());
	cout << it - dist.begin() << " " << *it << endl;

	return 0;
}
